m2m MACRO M1, M2
	push	M2
	pop	M1
ENDM
pushx MACRO parameters:VARARG
	LOCAL param, reversed, c
	param TEXTEQU <>
	reversed TEXTEQU <>
	forc c, <&parameters>
		IFIDN <c>, < >
			reversed CATSTR param, < >, reversed
			param TEXTEQU <>
		ELSE
			param CATSTR param, <c>
		ENDIF
	endm
	reversed CATSTR param, < >, reversed
	param TEXTEQU <>
%	forc c, <&reversed>
		IFIDN <c>, < >
			push	param
			param TEXTEQU <>
		ENDIF
		param CATSTR param, <c>
	endm
ENDM
popx MACRO parameters:VARARG
	LOCAL param, c
	param TEXTEQU <>
	forc c, <&parameters>
		IFIDN <c>, < >
			pop	param
			param TEXTEQU <>
		ENDIF
		param CATSTR param, <c>
	endm
	pop	param
ENDM
_call MACRO procedure, parameters:VARARG
	LOCAL param, reversed
	reversed TEXTEQU <>
%	for	param, <parameters>
		reversed CATSTR <param>, <!,>, reversed
	endm
%	for	param, <reversed>
		push	param
	endm
	call	dword ptr procedure
ENDM
string MACRO varname:REQ, strvalue:VARARG
	.const
		varname db strvalue, 0
	.code  
ENDM
showfmt MACRO fmtstr, values:VARARG
	LOCAL @@over, @@fmt
	jmp	@@over
	@@fmt db fmtstr, 0
@@over:	pushad
	invoke	GlobalAlloc, GMEM_MOVEABLE OR GMEM_ZEROINIT, 1000h
	push	eax
	push	eax
	invoke	GlobalLock, eax
	push	eax
	invoke	wsprintf, eax, ADDR @@fmt, values
	pop	eax
	invoke	MessageBox, 0, eax, 0, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
	call	GlobalUnlock
	call	GlobalFree
	popad
ENDM
showint MACRO caption, value
	LOCAL @@over, @@fmt
	jmp	@@over
	@@fmt db caption, " = %u", 0
@@over:	pushad
	mov	ebx, value
	invoke	GlobalAlloc, GMEM_MOVEABLE OR GMEM_ZEROINIT, 1000h
	push	eax
	push	eax
	invoke	GlobalLock, eax
	push	eax
	invoke	wsprintf, eax, ADDR @@fmt, ebx
	pop	eax
	invoke	MessageBox, 0, eax, 0, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
	call	GlobalUnlock
	call	GlobalFree
	popad
ENDM
showhex MACRO caption, value
	LOCAL @@over, @@fmt
	jmp	@@over
	@@fmt db caption, " = %08Xh", 0
@@over:	pushad
	mov	ebx, value
	invoke	GlobalAlloc, GMEM_MOVEABLE OR GMEM_ZEROINIT, 1000h
	push	eax
	push	eax
	invoke	GlobalLock, eax
	push	eax
	invoke	wsprintf, eax, ADDR @@fmt, ebx
	pop	eax
	invoke	MessageBox, 0, eax, 0, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
	call	GlobalUnlock
	call	GlobalFree
	popad
ENDM
showstr MACRO caption, value
	LOCAL @@over, @@fmt
	jmp	@@over
	@@fmt db caption, " = %s", 0
@@over:	pushad
	mov	ebx, value
	invoke	GlobalAlloc, GMEM_MOVEABLE OR GMEM_ZEROINIT, 1000h
	push	eax
	push	eax
	invoke	GlobalLock, eax
	push	eax
	invoke	wsprintf, eax, ADDR @@fmt, ebx
	pop	eax
	invoke	MessageBox, 0, eax, 0, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
	call	GlobalUnlock
	call	GlobalFree
	popad
ENDM
msgbox MACRO value
	pushad
	invoke	MessageBox, 0, value, 0, MB_OK OR MB_ICONASTERISK OR MB_APPLMODAL
	popad
ENDM
